/*
 * Copyright (c) 2022-present Charles7c Authors. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package top.continew.admin.business.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import top.continew.admin.business.model.entity.InviteRewardsRule;

/**
 * <p>
 * 邀请用户金币奖励规则 Mapper 接口
 * </p>
 *
 * @author xudm
 * @since 2024-12-15
 */
public interface InviteRewardsRuleMapper extends BaseMapper<InviteRewardsRule> {

    /**
     * 获取最大层级
     *
     * @return
     */
    int getMaxLevel();
}
