/*
 * Copyright (c) 2022-present Charles7c Authors. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package top.continew.admin.business.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.ibatis.annotations.Param;
import top.continew.admin.business.model.entity.TgUser;
import top.continew.admin.business.model.query.TgUserQuery;
import top.continew.admin.business.model.query.TgUserTeamQuery;

import java.util.List;

/**
 * <p>
 * tg用户 Mapper 接口
 * </p>
 *
 * @author xudm
 * @since 2024-12-14
 */
public interface TgUserMapper extends BaseMapper<TgUser> {

    List<TgUser> getTgUserOfPage(@Param("query") TgUserQuery query, Page page);

    /**
     * 查询团队用户
     *
     * @return
     */
    List<TgUser> getMyTeamUserListByType(@Param("query") TgUserTeamQuery query, Page<TgUser> page);

}
