/*
 * Copyright (c) 2022-present Charles7c Authors. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package top.continew.admin.business.model.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 邀请用户金币奖励规则
 * </p>
 *
 * @author xudm
 * @since 2024-12-15
 */
@Getter
@Setter
@TableName("b_invite_rewards_rule")
public class InviteRewardsRule extends Model<InviteRewardsRule> {

    /**
     * 主键
     */
    @TableId(value = "id", type = IdType.ASSIGN_ID)
    private Long id;

    /**
     * 奖励名称
     */
    @TableField("rewards_name")
    private String rewardsName;

    /**
     * 奖励说明
     */
    @TableField("rewards_describe")
    private String rewardsDescribe;

    /**
     * 邀请好友数量
     */
    @TableField("invite_num")
    private Integer inviteNum;

    /**
     * 金币数量
     */
    @TableField("gold_coin_num")
    private Integer goldCoinNum;

    /**
     * 奖励层级
     */
    @TableField("rewards_level")
    private int rewardsLevel;

    /**
     * 创建人
     */
    @TableField("created_by")
    private String createdBy;

    /**
     * 创建时间
     */
    @TableField("created_time")
    private LocalDateTime createdTime;

    /**
     * 更新人
     */
    @TableField("updated_by")
    private String updatedBy;

    /**
     * 更新时间
     */
    @TableField("updated_time")
    private LocalDateTime updatedTime;

    @Override
    public Serializable pkVal() {
        return this.id;
    }
}
