/*
 * Copyright (c) 2022-present Charles7c Authors. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package top.continew.admin.business.model.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 任务信息表
 * </p>
 *
 * @author xudm
 * @since 2024-12-15
 */
@Getter
@Setter
@TableName("b_task_info")
public class TaskInfo extends Model<TaskInfo> {

    /**
     * id
     */
    @TableId(value = "id", type = IdType.ASSIGN_ID)
    private Long id;

    /**
     * 任务名称
     */
    @TableField("name")
    private String name;

    /**
     * 名称日文
     */
    @TableField("name_ja")
    private String nameJa;

    /**
     * 名称韩文
     */
    @TableField("name_ko")
    private String nameKo;

    /**
     * 名称泰语
     */
    @TableField("name_th")
    private String nameTh;

    /**
     * 名称越南语
     */
    @TableField("name_vi")
    private String nameVi;

    /**
     * 名称俄语
     */
    @TableField("name_ru")
    private String nameRu;

    /**
     * 名称英文
     */
    @TableField("name_en")
    private String nameEn;

    /**
     * 名称葡萄牙语
     */
    @TableField("name_pt")
    private String namePt;

    /**
     * 名称波斯语
     */
    @TableField("name_fa")
    private String nameFa;

    /**
     * 名称西班牙语
     */
    @TableField("name_es")
    private String nameEs;

    /**
     * 任务说明
     */
    @TableField("instruction")
    private String instruction;

    /**
     * 任务图标
     */
    @TableField("task_icon")
    private String taskIcon;

    /**
     * 任务链接
     */
    @TableField("task_link")
    private String taskLink;

    /**
     * 任务分类编码
     */
    @TableField("category_code")
    private String categoryCode;

    /**
     * 1开启0关闭
     */
    @TableField("status")
    private Integer status;

    /**
     * 金币数量
     */
    @TableField("gold_coin")
    private Integer goldCoin;

    /**
     * 排序
     */
    @TableField("sort_num")
    private Integer sortNum;

    /**
     * 逻辑删除 0 未删除 1 已删除
     */
    @TableField("is_deleted")
    private Integer isDeleted;

    /**
     * 创建人
     */
    @TableField("create_by")
    private String createBy;

    /**
     * 更新人
     */
    @TableField("update_by")
    private String updateBy;

    /**
     * 创建时间
     */
    @TableField("create_time")
    private LocalDateTime createTime;

    /**
     * 更新时间
     */
    @TableField("updated_time")
    private LocalDateTime updatedTime;

    @Override
    public Serializable pkVal() {
        return this.id;
    }
}
