/*
 * Copyright (c) 2022-present Charles7c Authors. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package top.continew.admin.business.model.query;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.io.Serializable;

@Data
@Schema(description = "金币邀请查询参数")
public class InviteRewardsRuleQuery implements Serializable {

    @Schema(description = "奖励说明")
    private String rewardsDescribe;

    @Schema(description = "奖励名称")
    private String rewardsName;

    @Schema(description = "邀请好友数量")
    private int inviteNum;

    @Schema(description = "金币数量")
    private int goldCoinNum;

    @Schema(description = "页码")
    private int page;

    @Schema(description = "页大小")
    private int size;
}
