/*
 * Copyright (c) 2022-present Charles7c Authors. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package top.continew.admin.business.model.req;

import io.swagger.v3.oas.annotations.media.Schema;
import jakarta.validation.constraints.NotNull;
import lombok.Data;

import java.io.Serializable;

@Data
@Schema(description = "创建或修改空投参数")
public class AirdropManagerReq implements Serializable {

    @Schema(description = "空投目标人")
    @NotNull(message = "空投目标用户不能为空")
    private Long targetUser;

    @Schema(description = "空投金币数量")
    @NotNull(message = "空投金币数量不能为空")
    private Integer goldCoinNum;

    @Schema(description = "操作类型【0 新增空投 1 减去空投】")
    @NotNull(message = "操作类型不能为空")
    private Integer operationType;
}
