/*
 * Copyright (c) 2022-present Charles7c Authors. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package top.continew.admin.business.model.req;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.io.Serializable;

/**
 * <p>
 * 金币产出速率升级规则
 * </p>
 *
 * @author xudm
 * @since 2024-12-15
 */
@Data
@Schema(description = "创建或修改推进器参数")
public class CoinSpeedUpgradesRulesReq implements Serializable {

    /**
     * 消耗金币数量
     */
    @Schema(description = "消耗金币数量")
    private Integer consumeGoldCoin;

    /**
     * 消耗真实货币数量
     */
    @Schema(description = "消耗真实货币数量")
    private Integer realMoney;

    /**
     * 数值 每秒产量
     */
    @Schema(description = "数值 每秒产量")
    private String numericalValue;

    /**
     * 等级
     */
    @Schema(description = "等级")
    private Integer level;
}
