/*
 * Copyright (c) 2022-present Charles7c Authors. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package top.continew.admin.business.model.req;

import io.swagger.v3.oas.annotations.media.Schema;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import lombok.Data;

import java.io.Serializable;

@Data
@Schema(description = "创建或修改奖励规则参数")
public class InviteRewardsRuleReq implements Serializable {

    @Schema(description = "奖励名称")
    @NotNull(message = "奖励名称不能为空")
    private String rewardsName;

    @NotBlank(message = "奖励说明不能为空")
    @Schema(description = "奖励说明")
    private String rewardsDescribe;

    @NotNull(message = "邀请好友数量不能为空")
    @Schema(description = "邀请好友数量")
    private Integer inviteNum;

    @NotNull(message = "金币数量不能为空")
    @Schema(description = "金币数量")
    private Integer goldCoinNum;

}
