/*
 * Copyright (c) 2022-present Charles7c Authors. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package top.continew.admin.business.model.req;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.io.Serializable;

/**
 * <p>
 * 任务信息表
 * </p>
 *
 * @author xudm
 * @since 2024-12-15
 */
@Data
@Schema(description = "任务信息新增或修改参数")
public class TaskInfoReq implements Serializable {

    @Schema(description = "任务名称")
    private String name;

    @Schema(description = "名称日文")
    private String nameJa;

    @Schema(description = "名称韩文")
    private String nameKo;

    @Schema(description = "名称泰语")
    private String nameTh;

    @Schema(description = "名称越南语")
    private String nameVi;

    @Schema(description = "名称俄语")
    private String nameRu;

    @Schema(description = "名称英文")
    private String nameEn;

    @Schema(description = "名称葡萄牙语")
    private String namePt;

    @Schema(description = "名称波斯语")
    private String nameFa;

    @Schema(description = "名称西班牙语")
    private String nameEs;

    @Schema(description = "任务说明")
    private String instruction;

    @Schema(description = "任务图标")
    private String taskIcon;

    @Schema(description = "任务链接")
    private String taskLink;

    @Schema(description = "任务分类编码")
    private String categoryCode;

    @Schema(description = "1开启0关闭")
    private Integer status;

    @Schema(description = "金币数量")
    private Integer goldCoin;

    @Schema(description = "排序")
    private Integer sortNum;
}
