/*
 * Copyright (c) 2022-present Charles7c Authors. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package top.continew.admin.business.model.req;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Getter;
import lombok.Setter;

/**
 * <p>
 * 团队邀请配置
 * </p>
 *
 * @author xudm
 * @since 2024-12-16
 */
@Getter
@Setter
@Schema(description = "团队邀请配置新增或修改参数")
public class TeamInviteConfigReq {

    /**
     * A队抽成比例 百分比 0.01
     */
    @Schema(description = "A队抽成比例", example = "0.02")
    private String teamAScale;

    /**
     * B队抽成比例 百分比 0.01
     */
    @Schema(description = "B队抽成比例", example = "0.01")
    private String teamBScale;

    /**
     * 邀请一人金币奖励
     */
    @Schema(description = "邀请一人金币奖励", example = "1000")
    private Integer inviteOneReward;
}
