/*
 * Copyright (c) 2022-present Charles7c Authors. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package top.continew.admin.business.model.req;

import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

@Data
@Schema(description = "tg用户信息修改参数")
public class TgUserReq implements Serializable {
    //    /**
    //     * tg小程序id
    //     */
    //    @TableField("tg小程序id")
    //    private String tgId;
    //
    //    /**
    //     * tg账号
    //     */
    //    @TableField("tg账号")
    //    private String tgAccount;

    /**
     * 名
     */
    @TableField("名")
    private String firstName;

    /**
     * 姓
     */
    @TableField("姓")
    private String lastName;

    /**
     * 昵称
     */
    @TableField("昵称")
    private String nickname;

    /**
     * 真实姓名
     */
    @TableField("真实姓名")
    private String realName;

    /**
     * 头像
     */
    @TableField("头像")
    private String avatar;

    /**
     * 用户的语言的编码
     */
    @TableField("用户的语言的编码")
    private String languageCode;

    /**
     * 钱包地址
     */
    @TableField("钱包地址")
    private String walletAddress;

    /**
     * 币账户进入的唯一标识地址
     */
    @TableField("币账户进入的唯一标识地址")
    private String coinAddress;

    /**
     * 用户电话
     */
    @TableField("用户电话")
    private String mobile;

    /**
     * 用户性别: [1=男, 2=女]
     */
    @TableField("用户性别")
    private String sex;

    /**
     * 空投数量
     */
    @TableField("空投数量")
    private Integer airdropCoin;

    /**
     * 金币余额
     */
    @TableField("金币余额")
    private BigDecimal goldCoinAmount;

    /**
     * 金币总数量
     */
    @TableField("金币总数量")
    private BigDecimal goldCoinTotalHis;

    /**
     * 用户余额
     */
    @TableField("用户余额")
    private BigDecimal userAmount;

}
