/*
 * Copyright (c) 2022-present Charles7c Authors. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package top.continew.admin.business.service;

import com.baomidou.mybatisplus.extension.service.IService;
import top.continew.admin.business.model.entity.InviteRewardsRule;
import top.continew.admin.business.model.query.InviteRewardsRuleQuery;
import top.continew.admin.business.model.req.InviteRewardsRuleReq;
import top.continew.starter.extension.crud.model.resp.BasePageResp;

import java.util.List;

/**
 * <p>
 * 邀请用户金币奖励规则 服务类
 * </p>
 *
 * @author xudm
 * @since 2024-12-15
 */
public interface IInviteRewardsRuleService extends IService<InviteRewardsRule> {

    /**
     * 查询邀请用户金币奖励规则 分页
     *
     * @param query
     * @return
     */
    BasePageResp<InviteRewardsRule> InviteRewardsRulePage(InviteRewardsRuleQuery query);

    void delete(List<Long> ids);

    Long addRulesByLevel(InviteRewardsRuleReq inviteRewardsRule);

    void updateRules(Long id, InviteRewardsRuleReq req);

    List<InviteRewardsRule> getByIds(List<Long> ids);

    int getMaxLevel();

}
