/*
 * Copyright (c) 2022-present Charles7c Authors. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package top.continew.admin.business.service;

import com.baomidou.mybatisplus.extension.service.IService;
import top.continew.admin.business.model.entity.TaskInfo;
import top.continew.admin.business.model.query.TaskInfoQuery;
import top.continew.admin.business.model.req.TaskInfoReq;
import top.continew.starter.extension.crud.model.resp.BasePageResp;

/**
 * <p>
 * 任务信息表 服务类
 * </p>
 *
 * @author xudm
 * @since 2024-12-15
 */
public interface ITaskInfoService extends IService<TaskInfo> {

    BasePageResp<TaskInfo> getTaskInfoPage(TaskInfoQuery query);

    void updatetaskInfo(Long id, TaskInfoReq req);

    Long addTaskInfo(TaskInfoReq req);
}
