/*
 * Copyright (c) 2022-present Charles7c Authors. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package top.continew.admin.business.service;

import com.baomidou.mybatisplus.extension.service.IService;
import top.continew.admin.business.model.entity.TeamInviteConfig;
import top.continew.admin.business.model.query.TeamInviteConfigQuery;
import top.continew.admin.business.model.req.TeamInviteConfigReq;
import top.continew.starter.extension.crud.model.resp.BasePageResp;

/**
 * <p>
 * 团队邀请配置 服务类
 * </p>
 *
 * @author xudm
 * @since 2024-12-16
 */
public interface ITeamInviteConfigService extends IService<TeamInviteConfig> {

    /**
     * 分页查询团队邀请配置
     *
     * @param query
     * @return
     */
    BasePageResp<TeamInviteConfig> getTeamInviteConfigPage(TeamInviteConfigQuery query);

    /**
     * 更新队邀请配置
     *
     * @param id
     * @param req
     */
    void updateTeamInviteConfig(Long id, TeamInviteConfigReq req);

    /**
     * 新增队邀请配置
     *
     * @param req
     * @return
     */
    Long addTeamInviteConfig(TeamInviteConfigReq req);

}
