/*
 * Copyright (c) 2022-present Charles7c Authors. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package top.continew.admin.business.service;

import com.baomidou.mybatisplus.extension.service.IService;
import top.continew.admin.business.model.entity.TgUser;
import top.continew.admin.business.model.query.TgUserQuery;
import top.continew.admin.business.model.query.TgUserTeamQuery;
import top.continew.admin.business.model.req.TgUserReq;
import top.continew.starter.extension.crud.model.resp.BasePageResp;
import top.continew.starter.extension.crud.model.resp.PageResp;

import java.util.List;

/**
 * <p>
 * tg用户 服务类
 * </p>
 *
 * @author xudm
 * @since 2024-12-14
 */
public interface ITgUserService extends IService<TgUser> {
    /**
     * tg小程序用户登录
     *
     * @param query
     * @return
     */
    PageResp<TgUser> pageQuery(TgUserQuery query);

    void disableTgUserByIds(List<Long> ids);

    /**
     * 查询团队成员列表
     *
     * @return
     */
    BasePageResp<TgUser> getMyTeamUserListByType(TgUserTeamQuery queryVo);

    /**
     * 更新tg用户的信息
     *
     * @param id
     * @param req
     */
    void updateTgUserInfo(Long id, TgUserReq req);
}
