/*
 * Copyright (c) 2022-present Charles7c Authors. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package top.continew.admin.controller.business;

import io.swagger.v3.oas.annotations.tags.Tag;

import lombok.AllArgsConstructor;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import top.continew.admin.business.model.req.AirdropManagerReq;
import top.continew.admin.business.service.AirdropManagerService;

@RestController
@Tag(name = "空投管理")
@RequestMapping("airdrop/manager")
@AllArgsConstructor
public class AirdropManagerController {
    private final AirdropManagerService airdropManagerService;

    @PutMapping()
    public void airdropManager(@RequestBody @Validated AirdropManagerReq req) {
        airdropManagerService.airdropManager(req);
    }
}
